"""
Django settings for dcc project.

Generated by 'django-admin startproject' using Django 1.8.2.

For more information on this file, see
https://docs.djangoproject.com/en/1.8/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.8/ref/settings/
"""

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
import os

BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.8/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
# with open('/etc/secret_key.txt') as f:
    # SECRET_KEY = f.read().strip()
SECRET_KEY = 'd03(^r#38)_z#%dc9+15gb9i)=46__^!j8+bd&9!1ekr9h)%sw'
DATETIME_FORMAT = 'Y N j, H:i:s.u'
SHORT_DATETIME_FORMAT = 'Y-m-d'

ALLOWED_DOWNLOADS = ['BIGNARROWPEAK', 'BIGWIG', 'BIGBED']
SETTINGS_EXPORT = [
    'DEBUG',
    'ALLOWED_DOWNLOADS',
]

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True
COMPRESS_ENABLED = False
ALLOWED_HOSTS = []
GROUP = "test"
# Application definition

INSTALLED_APPS = (
    'admin_tools',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django_extensions',
    'modeldcc',
    'django_tables2',
    'crispy_forms',
    'compressor',
    'django_nose',
    'django.contrib.admin',
    'debug_toolbar.apps.DebugToolbarConfig',
    'django_cleanup',
    'djangojs',
    'webpack_loader',
    'rest_framework',
    'cachalot',
    'eztables',

)

MIDDLEWARE_CLASSES = (
    'django.contrib.sessions.middleware.SessionMiddleware',
    'debug_toolbar.middleware.DebugToolbarMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.views.decorators.csrf._EnsureCsrfCookie',
)

STATICFILES_FINDERS = (
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
    # other finders..
    'compressor.finders.CompressorFinder',
)

ROOT_URLCONF = 'dcc.urls'

CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.filebased.FileBasedCache',
        'LOCATION':  os.path.join(BASE_DIR,"django_cache"),
    }
}

WEBPACK_LOADER = {
    'DEFAULT': {
        'BUNDLE_DIR_NAME': 'js/bundles/',
        'STATS_FILE': os.path.join(BASE_DIR, '../webpack-local-stats.json'),
    }
}

CRISPY_TEMPLATE_PACK = 'bootstrap4'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        # 'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'django_settings_export.settings_export',
                # 'django.core.context_processors.request',
            ],
            'loaders': [
                'django.template.loaders.filesystem.Loader',
                'django.template.loaders.app_directories.Loader',
                'admin_tools.template_loaders.Loader',
            ],
        },
    },
]

# TEMPLATE_CONTEXT_PROCESSORS = [
#     'django.core.context_processors.request',
# ]

WSGI_APPLICATION = 'dcc.development_wsgi.application'
DJANGO_TABLES2_TEMPLATE = 'django_tables2/bootstrap4.html'

# LOGIN_REDIRECT_URL = '/dcc/modeldcc/'
LOGIN_URL = '/login/'

UPLOAD_PATH =  os.path.join(BASE_DIR,"modeldcc/fixtures/");

##EMAIL settings
EMAIL_BACKEND = 'django.core.mail.backends.smtp.EmailBackend'

# Host for sending e-mail.
EMAIL_HOST = 'localhost'
DEFAULT_FROM_EMAIL = 'no-reply@dcc.org'

# Port for sending e-mail.
EMAIL_PORT = 1025

# Optional SMTP authentication information for EMAIL_HOST.
EMAIL_HOST_USER = ''
EMAIL_HOST_PASSWORD = ''

#User registration settings
ACCOUNT_ACTIVATION_DAYS = 1 # One-day activation window;

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': 'testdata',
        'USER': 'test-user',
        'PASSWORD': 'duckpin-celsius-phony-glaucous-conspire-lisp-haggard-nucleate',
        'HOST': 'postgres',
        'PORT': 5432,
    }
}
TEST_RUNNER = 'django_nose.NoseTestSuiteRunner'

FILE_UPLOAD_HANDLERS = (
    'django.core.files.uploadhandler.TemporaryFileUploadHandler',
)

# Internationalization
# https://docs.djangoproject.com/en/1.8/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'US/Pacific'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)

STATIC_URL = '/static/'

STATIC_ROOT = os.path.join(BASE_DIR,"modeldcc/static_root")
STATICFILES_DIRS = (os.path.join(BASE_DIR, "dcc/static"),
                    os.path.join(BASE_DIR, "..", "node_modules/bootstrap/scss"))

MEDIA_URL = '/files/'
MEDIA_ROOT = os.path.join(BASE_DIR,"modeldcc/media_root/")
MEDIA_ROOT_ANNOT =  os.path.join(BASE_DIR,"modeldcc/media_root/annotated_files")
MEDIA_ROOT_DCC =  os.path.join(BASE_DIR,"modeldcc/media_root/")

DEBUG_TOOLBAR_PANELS = {
    'debug_toolbar.panels.versions.VersionsPanel',
    'debug_toolbar.panels.timer.TimerPanel',
    'debug_toolbar.panels.settings.SettingsPanel',
    'debug_toolbar.panels.headers.HeadersPanel',
    'debug_toolbar.panels.request.RequestPanel',
    'debug_toolbar.panels.sql.SQLPanel',
    'debug_toolbar.panels.staticfiles.StaticFilesPanel',
    'debug_toolbar.panels.templates.TemplatesPanel',
    'debug_toolbar.panels.cache.CachePanel',
    'debug_toolbar.panels.signals.SignalsPanel',
    'debug_toolbar.panels.logging.LoggingPanel',
    'debug_toolbar.panels.redirects.RedirectsPanel',
    'cachalot.panels.CachalotPanel',
}

CONN_MAX_AGE = 120
